Description

While reviewing the implementation for issue #4416 I noticed that the links to wikipages bound to versions do not respect

version-sharing (introduced in r3123 for issue #465 and enhanced with r3133 for issue #4357) in Settings -> Versions.

This leads to incorrect links when the version does not belong to the current project. More specifically, the links always point to the

current project wiki instead of the wiki of the actual versions project.

Another side-effect is that in the unless-statement again only the current project wiki is checked for existence instead of the actual

versions project wiki.

Related issues:

Related to Redmine - Feature #4416: Link from version details page to edit th... Closed 2009-12-16

Associated revisions

Revision 4307 - 2010-10-30 00:40 - Jean-Baptiste Barth

Fix wikilinks in project > settings > versions and version view. #6435 #4416

Contributed by Mischa The Evil and Felix Schäfer.

History

#1 - 2010-09-20 05:44 - Mischa The Evil

- File 6435-fix_links_to_wikipages_with_version-sharing.diff added

I've fixed this by wrapping source:/trunk/app/views/projects/settings/_versions.rhtml#L20 into a basic if-else structure (checking for version.project ==

@project) and adding a modified else-case statement (added :id-param containing version.project-value and changed unless statement to check

version.project.wiki.nil? instead of @project.wiki.nil?).

Here follows my patch (which also "fixes" two coding-standard inconsistencies (my third and fourth change)) which I'll attach seperately also:

Index: app/views/projects/settings/_versions.rhtml

===================================================================

--- app/views/projects/settings/_versions.rhtml    (revision 4101)

+++ app/views/projects/settings/_versions.rhtml    (working copy)

@@ -6,7 +6,7 @@

     <th><%= l(:field_description) %></th>

     <th><%= l(:field_status) %></th>

     <th><%= l(:field_sharing) %></th>

-    <th><%= l(:label_wiki_page) unless @project.wiki.nil? %></th>

+    <th><%= l(:label_wiki_page) %></th>

     <th style="width:15%"></th>

     </tr></thead>

     <tbody>

@@ -17,13 +17,19 @@

     <td class="description"><%=h version.description %></td>

     <td class="status"><%= l("version_status_#{version.status}") %></td>

     <td class="sharing"><%=h format_version_sharing(version.sharing) %></td>

-    <td><%= link_to(h(version.wiki_page_title), :controller => 'wiki', :page => Wiki.titleize(version.wiki_pa

ge_title)) unless version.wiki_page_title.blank? || @project.wiki.nil? %></td>

+    <td>

+        <% if version.project == @project %>

+            <%= link_to(h(version.wiki_page_title), :controller => 'wiki', :page => Wiki.titleize(version.wik

i_page_title)) unless version.wiki_page_title.blank? || @project.wiki.nil? %>
+        <% else %>

+            <%= link_to(h(version.wiki_page_title), :controller => 'wiki', :id => version.project, :page => W

iki.titleize(version.wiki_page_title)) unless version.wiki_page_title.blank? || version.project.wiki.nil? %>

+        <% end %>

+    </td>

     <td class="buttons">

         <% if version.project == @project %>

-            <%= link_to_if_authorized l(:button_edit),   {:controller => 'versions', :action => 'edit', :id =

> version }, :class => 'icon icon-edit' %>

+            <%= link_to_if_authorized l(:button_edit),   {:controller => 'versions', :action => 'edit', :id =

> version}, :class => 'icon icon-edit' %>

             <%= link_to_if_authorized l(:button_delete), {:controller => 'versions', :action => 'destroy', :i

d => version}, :confirm => l(:text_are_you_sure), :method => :delete, :class => 'icon icon-del' %>

         <% end %>

-       </td>

+    </td>

     </tr>

 <% end; reset_cycle %>

     </tbody>

 As visible from my 1st change it is required in Redmine now to always show the Wikipage heading because of that it is possible that inherited

versions contain bound wikipages while the current projects wiki does not exist.

#2 - 2010-09-20 05:48 - Mischa The Evil

Added relation to issue #4416 cause of its similarity regarding the scoping of links (started by Jean-Baptiste Barth in note-6).

#3 - 2010-10-02 01:18 - Eric Davis

- Category changed from Projects to Roadmap

- Target version set to 1.0.3

#4 - 2010-10-27 20:06 - Felix Schäfer

Included in a fix for #4416, I didn't take the if-block though, as it seems superfluous.

#5 - 2010-10-30 00:35 - Jean-Baptiste Barth

- Status changed from New to Resolved

- Assignee set to Mischa The Evil

- % Done changed from 0 to 100

- Resolution set to Fixed

Fix applied in r4307, thanks Mischa & Felix.

#6 - 2010-11-01 01:22 - Eric Davis

- Status changed from Resolved to Closed

Merged into 1.0-stable for release in 1.0.3

Files

6435-fix_links_to_wikipages_with_version-sharing.diff 2.07 KB 2010-09-20 Mischa The Evil

Powered by TCPDF (www.tcpdf.org)

2025-08-23 2/2

https://www.redmine.org/issues/4416
http://www.redmine.org/issues/4416#note-6
https://www.redmine.org/issues/4416
https://www.redmine.org/projects/redmine/repository/svn/revisions/4307
http://www.tcpdf.org

